import ReadingLogEntryEditor from "@components/ReadingLogEntryEditor.svelte";
import type { ReadingLogEntry } from "@src/types";
import { Event, EventEmitter } from "@utils/event";
import { App } from "obsidian";
import { SvelteModal } from "./svelte-modal";

export class SubmitEvent extends Event {
	constructor(public readonly entry: ReadingLogEntry) {
		super();
	}
}

interface ReadingLogNewEntryModalEventMap {
	submit: SubmitEvent;
}

export class ReadingLogNewEntryModal extends EventEmitter<
	ReadingLogNewEntryModalEventMap,
	typeof SvelteModal<typeof ReadingLogEntryEditor>
>(SvelteModal) {
	constructor(app: App) {
		super(app, ReadingLogEntryEditor, {
			props: {
				app,
				onSubmit: (entry: ReadingLogEntry) =>
					this.emit("submit", new SubmitEvent(entry)),
			},
		});
	}
}
